HDU 1331 Function Run Fun (基础记忆化搜索)

Function Run Fun

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 2602    Accepted Submission(s): 1263

Problem Description

We all love recursion! Don‘t we?

Consider a three-parameter recursive function w(a, b, c):

if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:

1

if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:

w(20, 20, 20)

if a < b and b < c, then w(a, b, c) returns:

w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)

otherwise it returns:

w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)

This is an easy function to implement. The problem is, if implemented directly, for moderate values of a, b and c (for example, a = 15, b = 15, c = 15), the program takes hours to run because of the massive recursion.

Input

The input for your program will be a series of integer triples, one per line, until the end-of-file flag of -1 -1 -1. Using the above technique, you are to calculate w(a, b, c) efficiently and print the
result.

Output

Print the value for w(a,b,c) for each triple.

Sample Input

1 1 1
2 2 2
10 4 6
50 50 50
-1 7 18
-1 -1 -1 

Sample Output

w(1, 1, 1) = 2
w(2, 2, 2) = 4
w(10, 4, 6) = 523
w(50, 50, 50) = 1048576
w(-1, 7, 18) = 1

Source

Pacific Northwest 1999

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1331

题目大意:如题

题目分析:对于有一个小于等于0的情况直接输出1,若有一个大于20,则搜索w(20,20,20),其他的直接搜w(a,b,c)采用记忆化搜索即可

#include <cstdio>
#include <cstring>
int const MAX = 60;
int dp[MAX][MAX][MAX];

int DFS(int a, int b, int c)
{
    if(a <= 0 || b <= 0 || c <= 0)
        return 1;
    if(dp[a][b][c])
        return dp[a][b][c];
    if(a < b && b < c)
        return dp[a][b][c] = DFS(a, b, c - 1) + DFS(a, b - 1, c - 1) - DFS(a, b - 1, c);
    else
        return dp[a][b][c] = DFS(a - 1, b, c) + DFS(a - 1, b - 1, c) + DFS(a - 1, b, c - 1) - DFS(a - 1, b - 1, c - 1);
}

int main()
{
    int a, b, c;
    while(scanf("%d %d %d", &a, &b, &c) != EOF)
    {
        if(a == -1 && b == -1 && c == -1)
            break;
        if(a <= 0 || b <= 0 || c <= 0)
        {
            printf("w(%d, %d, %d) = 1\n", a, b, c);
            continue;
        }
        if(a > 20 || b > 20 || c > 20)
        {
            printf("w(%d, %d, %d) = %d\n", a, b, c, DFS(20, 20, 20));
            continue;
        }
        printf("w(%d, %d, %d) = %d\n", a, b, c, DFS(a, b, c));
    }
}
时间: 2024-10-23 16:15:13

HDU 1331 Function Run Fun (基础记忆化搜索)的相关文章

HDU 1331 Function Run Fun(记忆化搜索)

Problem Description We all love recursion! Don't we? Consider a three-parameter recursive function w(a, b, c): if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:1 if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:w(20, 20, 20)

POJ 1579 Function Run Fun 【记忆化搜索入门】

题目传送门:http://poj.org/problem?id=1579 Function Run Fun Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 20560   Accepted: 10325 Description We all love recursion! Don't we? Consider a three-parameter recursive function w(a, b, c): if a <=

HDU 1978 How many ways (基础记忆化搜索)

How many ways Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 3475    Accepted Submission(s): 2041 Problem Description 这是一个简单的生存游戏,你控制一个机器人从一个棋盘的起始点(1,1)走到棋盘的终点(n,m).游戏的规则描述如下: 1.机器人一开始在棋盘的起始点并

HDU1331 HDU1579 Function Run Fun【记忆化搜索】

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1331 http://acm.hdu.edu.cn/showproblem.php?pid=1579 题目大意: 给一些递归条件,给你三个数a.b.c,求出w(a,b,c)是多少. 思路: 按题目要求递归的话会超时,所以用dp[a][b][c]来保存下递归函数的值,自底向上得出结果. AC代码: #include<iostream> #include<algorithm> #inclu

HDU 1331 Function Run Fun

Function Run Fun Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 2173    Accepted Submission(s): 1104 Problem Description We all love recursion! Don't we? Consider a three-parameter recursive fu

POJ 2704 Pascal&#39;s Travels (基础记忆化搜索)

Pascal's Travels Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 5328   Accepted: 2396 Description An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from t

HDU 4960 Another OCD Patient(记忆化搜索)

HDU 4960 Another OCD Patient 题目链接 记忆化搜索,由于每个碎片值都是正数,所以每个前缀和后缀都是递增的,就可以利用twopointer去找到每个相等的位置,然后下一个区间相当于一个子问题,用记忆化搜索即可,复杂度接近O(n^2) 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int INF = 0x3f3f3f

HDU 1208 Pascal&#39;s Travels( 记忆化搜索)

题目大意:每一小格代表能向右或者向下走几步,问从左上走到右下总共有多少种走法. dp[i][j]存放该格子有多少总走法. #include <iostream> #include <cstring> using namespace std; int n; char a[40][40]; int s[40][40]; __int64 dp[40][40]; int X[]={1, 0}; int Y[]={0, 1}; __int64 dfs(int x, int y) { if(d

HDU 1428 漫步校园 (BFS+优先队列+记忆化搜索)

题目地址:HDU 1428 先用BFS+优先队列求出所有点到机房的最短距离,然后用记忆化搜索去搜. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #include <stdlib.h> #include <map> #include <set> #incl